## gcc-m68hc1x 3.3.3-4

=== example/Makefile ===
#!/usr/bin/make -f

##################################################################
# Makefile for 68HC11 projects                                   #
# GNU copyright 2002-2003 by Aurelien Jarno <aurel32@debian.org> #
##################################################################

#
# Project files
#
PROG = test
ASMS = vectors.s
SRCS = main.c
INCLUDES = main.h ports.h 
OBJS = $(SRCS:.c=.o) $(ASMS:.s=.o)


#
# C flags used by default to compile a program
#
CFLAGS = -m68hc11 -mshort -Wall -Wmissing-prototypes -Os -g0 -msoft-reg-count=0 -fomit-frame-pointer -ffixed-z -fshort-enums 

LDFLAGS = -m68hc11 -mshort -Wl,-m,m68hc11elfb \
	  -Wl,-defsym,_io_ports=0x1000


#
# Options to creates the .s19 or .b files from the elf
#
OBJCOPY_FLAGS = --remove-section=page0 \
                --remove-section=.page0


####################################
# This part should not be modified #
####################################
#
# Programs location
#
DEVC_PREFIX=m68hc11-
CC=$(DEVC_PREFIX)gcc
CXX=$(DEVC_PREFIX)gcc
AS=$(DEVC_PREFIX)as
AR=$(DEVC_PREFIX)ar
SIZE=$(DEVC_PREFIX)size
OBJCOPY=$(DEVC_PREFIX)objcopy
OBJDUMP=$(DEVC_PREFIX)objdump
LD=$(DEVC_PREFIX)ld

#
# Main rules
#
all: 	$(PROG).elf $(PROG).s19 $(PROG).b

$(PROG).elf: $(OBJS) $(INCLUDES) memory.x
	$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBADD)

clean:
	rm -f *.o *.elf *.s19 *.b *.a

#
# Some useful rules
#
dump:	$(PROG).elf
	$(OBJDUMP) -d $(PROG).elf

size:   $(PROG).s19
	$(SIZE) $(PROG).s19


#
# Implicit rules
#
# .elf is for the simulator and gdb
# .s19 is for some downloader and the simulator
# .b   is a binary dump
#
.SUFFIXES: .elf .s19 .b

.elf.s19:
	$(OBJCOPY) --output-target=srec $(OBJCOPY_FLAGS) $< $*.s19

.elf.b:
	$(OBJCOPY) --output-target=binary --gap-fill=255 \
                   $(OBJCOPY_FLAGS) $< $*.b

=== debian/changelog ===
gcc-m68hc1x (3.3.3-4) unstable; urgency=low

  * Added some patches from upstream. Hope it would now build on all arches. 

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 22 Apr 2004 15:20:57 +0200

gcc-m68hc1x (3.3.3-3) unstable; urgency=low

  * Removed newlib from this package. It seems to cause some problems
    on some architectures whereas it build correctly as a separate 
    package.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 18 Apr 2004 04:36:57 +0200

gcc-m68hc1x (3.3.3-2) unstable; urgency=medium

  * Updated example program.
  * Newlib is now included in this package. 

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 12 Apr 2004 19:14:20 +0200

gcc-m68hc1x (3.3.3-1) unstable; urgency=low

  * gcc updated to 3.3.3 (closes: bug#241836).

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 11 Apr 2004 11:20:15 +0200

gcc-m68hc1x (3.2-10) unstable; urgency=low

  * Let gcc-m68hc1x provide its own manpages, instead of gcc-3.2's ones.
  * Removed the dependency on gcc-3.2.
  * Bumped standards-version to 3.6.1 (no changes).

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 17 Oct 2003 00:43:57 +0200

gcc-m68hc1x (3.2-9) unstable; urgency=low

  * Suggests gcc-3.2-doc instead of the non-existant package gcc-doc.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 27 Apr 2003 15:46:39 +0200

gcc-m68hc1x (3.2-8) unstable; urgency=low

  * Depends on ${misc:Depends}.
  * Uses debian/compat instead of DH_COMPAT.
  * Removed call to dh_undocumented.
  * Bumped standards-version to 3.5.9.

 -- Aurelien Jarno <aurel32@debian.org>  Mon,  7 Apr 2003 20:23:35 +0200

gcc-m68hc1x (3.2-7) unstable; urgency=low

  * Added m68hc11-gccbug and m68hc12-gccbug man pages.

 -- Aurelien Jarno <aurel32@debian.org>  Fri,  7 Feb 2003 14:45:29 +0100

gcc-m68hc1x (3.2-6) unstable; urgency=low

  * More fixes in example code. 

 -- Aurelien Jarno <aurel32@debian.org>  Wed,  8 Jan 2003 14:34:28 +0100

gcc-m68hc1x (3.2-5) unstable; urgency=low

  * Small fixes in example code. 

 -- Aurelien Jarno <aurel32@debian.org>  Wed,  8 Jan 2003 09:15:36 +0100

gcc-m68hc1x (3.2-4) unstable; urgency=low

  * Fixed description.
  * Added some examples to /usr/share/doc/gcc-m68hc1x/examples
  * Standards-Version bumped to 3.5.8

 -- Aurelien Jarno <aurel32@debian.org>  Tue,  7 Jan 2003 10:27:15 +0100

gcc-m68hc1x (3.2-3) unstable; urgency=low

  * Added newlib-m68hc1x to the "Suggests:" field.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 17 Dec 2002 00:21:43 +0100

gcc-m68hc1x (3.2-2) unstable; urgency=low

  * Strip libraries. 

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 25 Oct 2002 16:51:28 +0200

gcc-m68hc1x (3.2-1) unstable; urgency=low

  * Initial Release. (closes: bug#166106)

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 24 Oct 2002 07:51:05 +0200

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: gcc-m68hc1x
Section: devel
Priority: extra
Maintainer: Aurelien Jarno <aurel32@debian.org>
Standards-Version: 3.6.1
Build-Depends: autoconf2.13, binutils-m68hc1x (>= 2.14.90.0.7-1), libtool, awk, findutils, bzip2, gzip, bison, flex, gettext, texinfo, zlib1g-dev, debhelper (>= 4.0), toolchain-source (>= 3.3-1), tar (>= 1.13.18)

Package: gcc-m68hc1x
Architecture: any
Section: devel
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-m68hc1x (>= 2.14.90.0.7-1)
Suggests: task-c-devel, gcc-3.3-doc, newlib-m68hc1x
Provides: c-compiler-m68hc11, c-compiler-m68hc12
Description: The GNU C/C++ compiler for the Motorola 68HC11/12 processors
 This is the GNU C compiler, a fairly portable optimizing compiler which
 supports multiple languages. This package includes support for C and C++
 for cross-compiling to a Motorola 68HC11/12 microcontroller-based target.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE      := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE       := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

unpack: unpack-stamp
unpack-stamp:
	tar xjf /usr/src/toolchain/gcc.tar.bz2
	for i in $(CURDIR)/patches/* ; do \
		patch -p0 < $$i ; \
	done
	mv gcc-* src
	mkdir build
	touch unpack-stamp

configure: configure-stamp
configure-stamp: unpack-stamp
	dh_testdir

	# Add here commands to configure the package.
	cd build && \
	../src/configure --prefix=/usr \
                         --infodir=/usr/share/info \
                         --mandir=/usr/share/man \
                         --with-gnu-as \
                         --with-gnu-ld \
                         --enable-nls \
                         --without-included-gettext \
                         --disable-checking \
                         --enable-languages=c,c++ \
                         --build=$(DEB_BUILD_GNU_TYPE) \
                         --host=$(DEB_HOST_GNU_TYPE) \
                         --target=m68hc11
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	cd build && $(MAKE)
	tar cfz $(CURDIR)/example.tar.gz example
	touch build-stamp

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/gcc-m68hc1x
	cd build && $(MAKE) install \
            prefix=$(CURDIR)/debian/gcc-m68hc1x/usr \
            infodir=$(CURDIR)/debian/gcc-m68hc1x/usr/share/info \
            mandir=$(CURDIR)/debian/gcc-m68hc1x/usr/share/man 
	    
	# Remove uneeded hardlink
	rm $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc11-gcc-3.3.3*
	
	# Change hardlinks to symlinks
	ln -sf m68hc11-c++ $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc11-g++
  
  	# Rename manpages and create symlinks
	rm $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc11-g++.1
	mv $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/cpp.1 $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc11-cpp.1
	mv $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/gcov.1 $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc11-gcov.1
	ln -s m68hc11-gcc.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc11-g++.1.gz
	ln -s m68hc11-gcc.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc11-c++.1.gz

	# Also create m68hc12-*
	ln -s m68hc11-gccbug $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc12-gccbug
	ln -s m68hc11-gcov $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc12-gcov
	ln -s m68hc11-cpp $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc12-cpp
	cp debian/m68hc12-gcc $(CURDIR)/debian/gcc-m68hc1x/usr/bin
	cp debian/m68hc12-c++ $(CURDIR)/debian/gcc-m68hc1x/usr/bin
	ln -s m68hc12-c++ $(CURDIR)/debian/gcc-m68hc1x/usr/bin/m68hc12-g++
	ln -s m68hc11-cpp.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc12-cpp.1.gz
	ln -s m68hc11-gcc.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc12-gcc.1.gz
	ln -s m68hc11-g++.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc12-c++.1.gz
	ln -s m68hc11-g++.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc12-g++.1.gz
	ln -s m68hc11-gcov.1.gz $(CURDIR)/debian/gcc-m68hc1x/usr/share/man/man1/m68hc12-gcov.1.gz

	# Files also in main gcc-3.3 pkg
	cd $(CURDIR)/debian/gcc-m68hc1x/usr/ && \
		rm -rf share/man/man7/fsf-funding.7* \
		     share/man/man7/gfdl.7* \
		     share/man/man7/gpl.7* \
		     share/locale \
		     share/info \
		     lib/libiberty.a

	# Strip files
	find $(CURDIR)/debian/gcc-m68hc1x -name "*.o" -or -name "*.a" -exec /usr/bin/m68hc11-strip --strip-debug {} \;

	# Override file
	install -p -o root -g root -m 644 $(CURDIR)/debian/overrides $(CURDIR)/debian/gcc-m68hc1x/usr/share/lintian/overrides/gcc-m68hc1x
				
clean:
	dh_testdir
	dh_testroot
	make -C example/ clean
	rm -f $(CURDIR)/example.tar.gz
	rm -rf src build
	rm -f build-stamp configure-stamp unpack-stamp

	dh_clean


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
#	dh_installexamples
#	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
	dh_installman
#	dh_installinfo
	dh_installchangelogs
	dh_link
	dh_strip --exclude=.o --exclude=.a
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
